import * as i0 from '@angular/core';
import { Injectable, Component, Directive, Input, NgModule } from '@angular/core';

class NgxLazyNgforService {
    loadMore(quantity, originalObject, lazyObject, counter) {
        if (originalObject.length - counter > quantity) {
            for (let i = counter; i < counter + quantity; i++) {
                lazyObject.push(originalObject[i]);
            }
        }
        else {
            const rest = originalObject.length - counter;
            const limit = counter + rest;
            if (counter < originalObject.length) {
                for (let i = counter; i < (limit); i++) {
                    lazyObject.push(originalObject[i]);
                }
            }
        }
    }
}
NgxLazyNgforService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxLazyNgforService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class NgxLazyNgforComponent {
    constructor() { }
    ngOnInit() {
    }
}
NgxLazyNgforComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgxLazyNgforComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: NgxLazyNgforComponent, selector: "lib-ngx-lazy-ngfor", ngImport: i0, template: `
    <p>
      ngx-lazy-ngfor works!
    </p>
  `, isInline: true });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lib-ngx-lazy-ngfor',
                    template: `
    <p>
      ngx-lazy-ngfor works!
    </p>
  `,
                    styles: []
                }]
        }], ctorParameters: function () { return []; } });

class LazyForDirective {
    constructor(elementr, ngxLazyNgforService, view, template) {
        this.elementr = elementr;
        this.ngxLazyNgforService = ngxLazyNgforService;
        this.view = view;
        this.template = template;
        this.lazyObject = [];
        this.quantity = 5;
        this.counter = 0;
    }
    set lazyForOf(collection) {
        this.counter = 0;
        this.startOject = collection;
        this.view.clear();
        this.ngxLazyNgforService.loadMore(this.quantity, this.startOject, this.lazyObject, this.counter);
        this.lazyObject.forEach((item, index) => {
            this.view.createEmbeddedView(this.template, { $implicit: item, index });
        });
        this.lazyObject = [];
        this.elementr.nativeElement.parentElement.addEventListener('scroll', (event) => {
            ;
            this.emitScrollInBottom(event.target);
        });
    }
    ;
    //detect if scroll position is in bottom of component
    isInBottom(element) {
        return element.scrollTop + element.offsetHeight >= element.scrollHeight;
    }
    //emit event when scroll position is in bottom of component
    emitScrollInBottom(element) {
        if (this.isInBottom(element)) {
            if (this.counter < this.startOject.length) {
                this.counter += this.quantity;
                this.ngxLazyNgforService.loadMore(this.quantity, this.startOject, this.lazyObject, this.counter);
                this.lazyObject.forEach((item, index) => {
                    this.view.createEmbeddedView(this.template, { $implicit: item, index });
                });
                this.lazyObject = [];
            }
        }
    }
}
LazyForDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: LazyForDirective, deps: [{ token: i0.ElementRef }, { token: NgxLazyNgforService }, { token: i0.ViewContainerRef }, { token: i0.TemplateRef }], target: i0.ɵɵFactoryTarget.Directive });
LazyForDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.16", type: LazyForDirective, selector: "[lazyFor][lazyForOf]", inputs: { quantity: "quantity", lazyForOf: "lazyForOf" }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: LazyForDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[lazyFor][lazyForOf]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: NgxLazyNgforService }, { type: i0.ViewContainerRef }, { type: i0.TemplateRef }]; }, propDecorators: { quantity: [{
                type: Input
            }], lazyForOf: [{
                type: Input
            }] } });

class NgxLazyNgforModule {
}
NgxLazyNgforModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxLazyNgforModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforModule, declarations: [NgxLazyNgforComponent,
        LazyForDirective], exports: [NgxLazyNgforComponent,
        LazyForDirective] });
NgxLazyNgforModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: NgxLazyNgforModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxLazyNgforComponent,
                        LazyForDirective
                    ],
                    imports: [],
                    exports: [
                        NgxLazyNgforComponent,
                        LazyForDirective
                    ]
                }]
        }] });

class ConfigObject {
}

/*
 * Public API Surface of ngx-lazy-ngfor
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ConfigObject, LazyForDirective, NgxLazyNgforComponent, NgxLazyNgforModule, NgxLazyNgforService };
//# sourceMappingURL=ngx-lazy-ngfor.js.map
